"""
Toward higher-order functions

Dan Armendariz
danallan@cs.harvard.edu
"""

# create an arbitrary list of numbers
nums = [1, 5, 10, 8, -4, 432]

print "Initial:", nums

def apply_to_all(f, items):
    """ Apply a function f to every item in a list """
    result = []
    for item in items:
        new_item = f(item)
        result.append(new_item)
    return result

def incrementor(num):
    """ Increment a number by 1 """
    return num + 1

def doubler(num):
    """ Double a number """
    return num * 2

print "Add 1:  ", apply_to_all(incrementor, nums)
print "Double: ", apply_to_all(doubler, nums)
