"""
Using Python's built-in Higher-Order Functions (HOFs): reduce

Dan Armendariz
danallan@cs.harvard.edu
"""

# create an arbitrary list of numbers
nums = [1, 5, 10, 8, -4, 432]

print "Initial:", nums

def add(x, y):
    """ Sum two numbers """
    return x + y

def multiply(x, y):
    return x * y

# the `reduce` function is a HOF that collapses a list to a single value
print "Sum of all values: ", reduce(add, nums, 0)
print "Multiply all values: ", reduce(multiply, nums, 1)

"""
Reduce operates in this way:
We want to sum all of the objects, so we provide our function `sum` to reduce()
It then applies sum on the first element and the initial value, and the
output of that function is then used as input to the next iteration.

Let's say we have a list [1, 5, 8]
The first operation would be:
sum(0, 1) -- "0" is our initial value. The output is 1

1 is used as one of the next inputs; the other is the next item in the list
sum(1, 5) -- outputs "6"

sum(6, 8) -- outputs our final value, 14!

Note: the order is not guaranteed!
"""